#include <assert.h>
#include <pthread.h>

#include "barrier.h"
#include "common.h"

void barrier_init(barrier_t* bar_name, int num_procs) {
    bar_name->counter = 0;
    bar_name->flag = FALSE;
    bar_name->num_procs = num_procs;
    assert(!pthread_mutex_init(&bar_name->lock, NULL));
}

void barrier(barrier_t* bar_name, int* local_sense) {
    *local_sense = *local_sense ? FALSE : TRUE;

    pthread_mutex_lock(&bar_name->lock);
    bar_name->counter++;
    pthread_mutex_unlock(&bar_name->lock);
    
    if (bar_name->counter == bar_name->num_procs) {
        bar_name->counter = 0;
        bar_name->flag = *local_sense;
    } else {
        while(bar_name->flag != *local_sense) {
            // busy wait
        }; 
    }
}

void barrier_destroy(barrier_t* bar_name) {
    assert(!pthread_mutex_destroy(&bar_name->lock));
}
