#ifndef _TSP_H_
#define _TSP_H_

#define MAX_NAME_LENGTH 100
#define TRUE 1
#define FALSE 0

typedef struct {
  float lat;
  float lon;
  char* name;
} city_t;

typedef struct {
  int* order; // this member's order of cities
  double fitness; // the distance of this member's path
} pop_mem_t;


void breed();

// calculate and set the fitness of the idxth population member
void calc_fitness(int idx);

// args: the indices of the parent and the child; whether to print the
// parents and child
// use the parents to generate the child in child by making the first
// half of the child a half of the mom starting from some random
// index, and then copying into the child the remaining cities in the
// order they appear in dad
void crossover(int mom, int dad, int child, int echo);

// sort the population in-place by descending fitness
// indices greater than pop are automatically reused, and thus
// implicitly culled 
void cull();

void deallocate();

// return the distance between the cities at indices a and b
double distance(int a, int b);

// generate the initial population
// whether to print the population
void gen_pop(int echo);

// the number of arguments, their values, and whether to print the
// parsed data
// also initializes the random number generator
void parse_args(int argc, char** argv, int echo);

void print_args();
void print_cities();
void print_city();

// print the idxth member of pop
void print_member(int idx);

// if all, prints children too
void print_pop(int all);

void print_solution();
void print_solution_long();

void quick_sort(int left, int right);

// randomly swap two cities in pop_idx's order
void random_swap(int pop_idx);

#endif
